#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* http://docs.unity3d.com/Manual/SL-VertexFragmentShaderExamples.html */

float4
bars(
    __global global_buffers * g,
    VS_OUTPUT * in,
    float2 offset,
    __global float * c) 
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );

    float4 color0 = makef4_ffff(in->objPos.x * 2.0, in->objPos.y * 2.0, 1.0, 1.0); 
    float4 color1 = makef4_ffff(0.3, 0.3, 0.3, 1.0); 

    float strip = abs_f(10.0f * in->objPos.x);
    float i = floor_f(strip + 0.5f) - floor_f(strip);
    return add_f4f4(mul_f4f(color1, i), mul_f4f(color0, (1.0f - i)));
}
