#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* Frame order:
 *   FILTER_MODE_NONE
 */
float4
checker( __global global_buffers * g, VS_OUTPUT * in, float2 offset, __global float * c )
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );
    float rx = floor_f( in->objPos.x + 0.5f ) - floor_f( in->objPos.x );
    float ry = floor_f( in->objPos.y + 0.5f ) - floor_f( in->objPos.y );
    return makef4_f( lerp_ff( 1.0f, 0.0f, rx*ry + (1.0f-rx)*(1.0f-ry) ) );
}
