#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* Frame order:
 *   FILTER_MODE_NONE
 */
float4
checker2( __global global_buffers * g, VS_OUTPUT * in, float2 offset, __global float * c )
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );
    float rx = step_f( fract_f( in->objPos.x ), 0.5f );
    float ry = step_f( fract_f( in->objPos.y ), 0.5f );
    return makef4_f( lerp_ff( 1.0f, 0.0f, rx*ry + (1.0f-rx)*(1.0f-ry) ) );
    /*
    float rx;
    rx = fract_f( in->objPos.x );
    k/rx = step_f( rx, 0.5f );
    return makef4_f( rx );
    */

    /*
    float3 sum, diff;
    float maxx, maxy;

    sum  = add_f3f3( in->dwdx, in->dwdy );
    diff = sub_f3f3( in->dwdx, in->dwdy );
    maxx = fmax( abs_f( sum.x ), abs_f( diff.x ) );
    maxy = fmax( abs_f( sum.y ), abs_f( diff.y ) );
    in->dwdx = makef3_fff( maxx, 0.0f, 0.0f );
    in->dwdy = makef3_fff( 0.0f, maxy, 0.0f );
    
    return makef4_ffff(
        in->dwdx.x, in->dwdy.y, 0.0f,
        0.0f
    );
    */
}
