#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* Frame order:
 *   FILTER_MODE_NONE
 */
float4
circles( __global global_buffers * g, VS_OUTPUT * in, float2 offset, __global float * c )
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );
    float rx = sq_f( fract_f( in->objPos.x * 10.0f ) - 0.5f );
    float ry = sq_f( fract_f( in->objPos.y * 10.0f ) - 0.5f );
    return makef4_f( step_f( rx+ry, 0.2f ) );
}
