#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* oh so loosely adapted from https://www.shadertoy.com/view/Ms2SD1 */ 

float
min_f( float a, float b )
{
    return ( a + b - abs_f( a - b ) ) * 0.5f;
}

float4
depthillusion(
    __global global_buffers * g,
    VS_OUTPUT * in,
    float2 offset,
    __global float * c) 
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );

    const float4 SEA_BASE        = makef4_ffff( 0.1f, 0.19f, 0.22f, 1.0f );
    const float4 SEA_WATER_COLOR = makef4_ffff( 0.8f, 0.90f, 0.60f, 1.0f );

    float3 uv = mul_f3f( in->objPos, 10.0f );
    float f = min_f( sin(uv.x), cos(uv.y) );
    return lerp_f4f(SEA_BASE, SEA_WATER_COLOR, abs_f( f ) );
}
