#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* http://glslsandbox.com/e#24326.0 */


float
mylength( float2 pos )
{
    return sqrt(pos.x * pos.x + pos.y * pos.y); 
}

float 
myfract( float x ) 
{
        return x - floor(x) ; 
} 

float4
hazard(
    __global global_buffers * g,
    VS_OUTPUT * in,
    float2 offset,
    __global float * c) 
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );
    const float time = M_PI / 4.0 ; 
    const float m = 0.125;
    float2 p = 
      makef2_ff( fmod(abs_f(in->objPos.x*2), m) - m * 0.5 ,
                 fmod(abs_f(in->objPos.y*2), m) - m * 0.5 ); 
    float a = atan2(p.x,p.y)+time;
    float r = mylength(p);
    float symbol = step_f(myfract(a/2.0943951),0.5) * 
                  (step_f(r,m*0.5)*step_f(m*0.15,r)) + 
                   step_f(r,m*0.1);
    return makef4_ffff(symbol, symbol, 0.0, 1.0); 
}
