#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* http://glslsandbox.com/e#24340.4 */ 

float4
oilgrid(
    __global global_buffers * g,
    VS_OUTPUT * in,
    float2 offset,
    __global float * c) 
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );
        
    float time = 10.0 * abs_f(in->objPos.x + in->objPos.y) ; 

    float color = 0.0;
    color += sin( in->objPos.x * cos( time / 15.0 ) * 80.0 ) + cos( in->objPos.y * cos( time / 15.0 ) * 80.0 );
    color += sin( in->objPos.y * sin( time / 10.0 ) * 40.0 ) + cos( in->objPos.x * sin( time / 25.0 ) * 80.0 );
    color += sin( in->objPos.x * sin( time / 5.0 ) * 10.0 ) + sin( in->objPos.y * sin( time / 35.0 ) * 80.0 );
    color *= sin( time / 10.0 ) * 0.5;

    return makef4_ffff( color, color * 0.5, 
        sin( color + time / 3.0 ) * 0.75 , 1.0 );
}
