#ifndef PROCEDURAL_SHADERS_H
#define PROCEDURAL_SHADERS_H

#include "api3d.h"

#define X "x"
#define Y "y"
#define Z "z"
typedef struct VS_OUTPUT {
    float3 worldPos;     /* World-space position */

    __attribute__((dim(X,X), dim(Y,Y), dim(Z,Z)))
    float3 objPos;       /* Object-space position */

    float3 worldNorm;    /* World-space normal */

    __attribute__((width(X, X)))
    float3 dwdx;         /* distance in world coordinates between projections of pixels onto the surface */

    __attribute__((width(Y, Y)))
    float3 dwdy;         /* distance in world coordinates between projections of pixels onto the surface */

    /*float2 textureUV;*/    /* Texture coordinates */
    /*float4 position;*/     /* Clip-space position */
    /*float4 posPrev;*/
    /*float3 vViewWS;*/ /* Vector from camera to viewpoint, unnormalized */

    float3 vLightDirVec; /* Vector from light to the viewpoint, unnormalized */

    /*float2 oldTextureUV;*/ /* Pre-displaced texture coordinates for the displacement shader */
} VS_OUTPUT;

#endif /* PROCEDURAL_SHADERS_H */

