#include <math.h>

#include "api3d.h"
#include "factors.h"
#include "procedural_shaders.h"
#include "procedural_helpers.h"
#include "reprojection.h"
#include "prng.h"

#include "api3d_bl.c"

/* http://glslsandbox.com/e#24342.0 */ 

float4
spiral(
    __global global_buffers * g,
    VS_OUTPUT * in,
    float2 offset,
    __global float * c) 
{
    axis_align_widths( &( in->dwdx ), &( in->dwdy ) );
        
    float time = 1.0; 

    float a = atan2(in->objPos.x*10 , in->objPos.y*10);
    float r = sq_f( in->objPos.x ) + sq_f( in->objPos.y );
    float cc = fabs(sin(6.*fabs(sin(4.*fabs(sin(2.*r+a*.5-time*99.))))));
    return makef4_ffff( cc, cc, cc, 1.0); 
}
