#!/bin/sh

if [ $# -lt 2 ] ; then
    echo "Usage: $0 function clname source-name"
    exit 1;
fi

root=`dirname "$0"`
root=`cd "$root" ; pwd`

func=$1
cl=$2
src=$3

if [ "X${LOG_SCRIPT_ARGS:+set}" = "Xset" ] ; then
    echo "$0" "$@" >> "$root/../scriptlog"
fi

#-I /home/jad5ju/Progs/opensource/clFFT/src/include

tmpsrc=`mktemp --suffix .c`
"$root/zeroinit" "$src" -o "$tmpsrc"
status=$?
case $status in
  0) : ;;
  *) rm -f "$tmpsrc"; exit $status ;;
esac

"$root/c2opencl" "$tmpsrc" "$func" -o "$cl"
status=$?
case $status in
  0) : ;;
  *) rm -f "$tmpsrc" "$cl" ; exit $status ;;
esac

rm "$tmpsrc"
exit $status
