open Cil
open Utils

module type WidthAnalysis =
sig
  type t

  val init : bool -> Cil.file -> unit

  val initStartData : int -> Cil.varinfo list -> unit

  val compute : Cil.stmt list -> unit

  val getData : int -> t

  val transformExp : t -> Cil.exp -> Cil.exp option

  val transformFunc : t -> string -> Cil.lval option -> Cil.exp list -> Cil.instr list option
end

module Make : functor (WA : WidthAnalysis) ->
sig
  val init : bool -> Cil.file -> unit

  val apply : Cil.fundec -> ISet.t -> ISet.t
end

